/* ---------------------------------------------------------------------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.  

   Copyright (c) 2001-2002 by Michal Ociepka <armadillo@wp.pl>

   For more info:
   http://xdefactor.republika.pl
   --------------------------------------------------------------------- */

#include <stdlib.h>
#include <fcntl.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include "callbacks.h"
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>
#include <postgresql/libpq-fe.h>
#include <memory.h>
#include <gnome.h>

#include "libfix5.h"

#define S SPRZEDAWCA
#define X XDEFACTOR

void drukuj_wz(){
	FILE *fp;
	gchar *home, *home_def, *getenv();
	const gchar *file_name = "wz_swap";
	int a, b, c;
	gint lp, pomiar, licznik_linii;
	gchar buff[300], key[10], buff_[5];
	extern gchar nazwa_firm[100];
        extern PGconn *conn;
        extern PGresult *res;
	gchar *trik;
	//teraz pola entry z wz.c
	extern GtkWidget 
			 *wz_entry2,
		         *wz_entry4,
			 *wz_entry5,
			 *wz_entry6,
			 *wz_entry7,
			 *wz_entry8,
			 *wz_entry9,
			 *wz_entry14,
			 *wz_clist4,
			 *combo_wz_entry1;

	if((home = getenv("HOME")) == (char *) 0) {
		printf("Twoj katalog domowy nie jest zdefiniowany!!\n Podaj teraz jego sciezke: \n");	
		scanf("%s", &home_def);
		chdir(home_def);
	}else{
	chdir(home);
	}
	nr_wz(key);

	fp = fopen(file_name, "w");
	
	fputs("+", fp);
	for(a=1; a < 39; a++)
		fputs("-", fp);
	fputs("+", fp);
	fputs("\n", fp);
	for(b=1; b < 8; b++){
		fputs("|", fp);
		for(a=1; a < 39; a++)
			fputs(" ", fp);
		fputs("|", fp);
		for(c=1; c < 40; c++)
			fputs(" ", fp);
		switch (b){
		case 1:	fputs("MIEJSCE WYSTAWIENIA : ", fp); 
			fputs(ENTRY_GET_TEXT(wz_entry2), fp);
			break;
		case 2: fputs("DATA WYSTAWIENIA    : ", fp);
			fputs(ENTRY_GET_TEXT(wz_entry4), fp);
			break;
		case 3: fputs("DATA WYSYKI	   : ",  fp);
			fputs(ENTRY_GET_TEXT(wz_entry5), fp);
			break;
		}
		fputs("\n", fp);
	}
	fputs("+", fp);
	fputs("-", fp);
	fputs("-", fp);
	fputs("Piecz firmy", fp);
	for(a=1; a < 24;a++)
		fputs("-", fp);
	fputs("+", fp);
	fputs("\n", fp);
	fputs("\n", fp);
	fputs("\n", fp);
	
	for(a=1; a < 41; a++)
		fputs(" ", fp);	
	fputs("[ O R Y G I N A  / K O P I A ]",fp);
		fputs("\n", fp);
		fputs("\n", fp);
	fputs("SPRZEDAWCA \n", fp);
	chdir("/etc/xdefactor");

	szukaj(S, "nazwa_firmy", buff);
		fputs(buff, fp);
		fputs(" ", fp);
	szukaj(S, "wlasciciel", buff);
		fputs(buff, fp);
		fputs("\n", fp);
	szukaj(S, "ulica", buff);
		fputs("ul. ", fp);
		fputs(buff, fp);
		fputs("\n", fp);
	szukaj(S, "kod_pocztowy", buff);
		fputs(buff, fp);
		fputs(" ", fp);
	szukaj(S, "miejscowosc", buff);
		fputs(buff, fp);
		fputs("\n", fp);
	szukaj(S, "nip", buff);
		fputs("NIP: ", fp);
		fputs(buff, fp);
		fputs("\n", fp);
	szukaj(S, "tel", buff);
		fputs("Tel: ", fp);
		fputs(buff, fp);
		fputs("\n", fp);
	szukaj(S, "fax", buff);
		fputs("Fax: ", fp);
		fputs(buff, fp);
		fputs("\n", fp);
	szukaj(S, "konto", buff);
		fputs("Konto   : ", fp);
		fputs(buff, fp);
		fputs("\n", fp);
	szukaj(S,"nr_konta", buff);
		fputs("Nr konta: ", fp);
		fputs(buff, fp);
		fputs("\n", fp);

	for(a=1; a < 3; a++)	
		fputs("\n", fp);
// a teraz najwiekszy numer wz
	for(a=1; a < 40; a++)
		fputs(" ", fp);
	fputs(" D O K U M E N T  W Z  N R: ", fp);
	fputs(key, fp);

	for(a=1; a < 3; a++)	
		fputs("\n", fp);
	
//teraz drukujemy nabywce

	
	fputs("NABYWCA \n", fp);
	fputs(nazwa_firm, fp);
		fputs("\n", fp);
	sprintf(buff, "SELECT ulica FROM nabywca WHERE nazwa LIKE '%%%s%';", nazwa_firm);
		res = PQexec(conn, buff);
		fputs("ul. ", fp);
		fputs(PQgetvalue(res, 0, 0), fp);
		fputs("\n", fp);
	sprintf(buff, "SELECT kod_pocztowy FROM nabywca WHERE nazwa LIKE '%%%s%';", nazwa_firm);
		res = PQexec(conn, buff);
		fputs(PQgetvalue(res, 0, 0), fp);
		fputs(" ", fp);
	sprintf(buff, "SELECT miejscowosc FROM nabywca WHERE nazwa LIKE '%%%s%';", nazwa_firm);
		res = PQexec(conn, buff);
		fputs(PQgetvalue(res, 0, 0), fp);
		fputs("\n", fp);
	sprintf(buff, "SELECT nip FROM nabywca WHERE nazwa LIKE '%%%s%';", nazwa_firm);
		res = PQexec(conn, buff);
		fputs("NIP: ", fp);
		fputs(PQgetvalue(res, 0, 0), fp);

	fputs("\n", fp);
	fputs("\n", fp);



	fputs("\n", fp);
	fputs("\n", fp);

	fputs("rodek transportu  : ", fp);
		fputs(ENTRY_GET_TEXT(wz_entry7), fp);
		fputs("\n", fp);
	fputs("Zamwienie	   : ", fp);
		fputs(ENTRY_GET_TEXT(wz_entry6), fp);
		fputs("\n", fp);
	fputs("Przeznaczenie	   : ", fp);
		fputs(ENTRY_GET_TEXT(wz_entry14), fp);
		fputs("\n", fp);
	fputs("Numer magazynowy   : ", fp);
		fputs(ENTRY_GET_TEXT(wz_entry9), fp);
		fputs("\n", fp);
	fputs("Wysyka na koszt   : ", fp);
		fputs(ENTRY_GET_TEXT(combo_wz_entry1), fp);
		fputs("\n", fp);
	fputs("Nr i data faktury  : ", fp);
		fputs(ENTRY_GET_TEXT(wz_entry8), fp);
		fputs("\n", fp);

	fputs("\n", fp);
	fputs("\n", fp);
	fputs("\n", fp);
	
	fputs("+====+==========================================+============ I L O   ======+================================+\n", fp);
	fputs("|Lp. |      Nazwa towaru	  		| Zadysponowana | jm | Wydana |          Uwagi                 |\n", fp); 
	fputs("+==============================================================================================================+\n", fp);			
	
	lp = 1;
	pomiar = 0;
	licznik_linii = 0;
	while(CLIST_GET_TEXT(wz_clist4, pomiar, 0, &trik) != 0){
		CLIST_GET_TEXT(wz_clist4, pomiar, 1, &trik);
		szukaj(X, "ilosc_linii_a4_f8", buff);
		
		if(atoi(buff) != 0)
		if(licznik_linii == atoi(buff)){
			for(a=1; a<5; a++)
				fputs("\n", fp);
		}
		

		licznik_linii++;

		sprintf(buff, "|%4.0d|", lp);
			fputs(buff, fp);
		
		CLIST_GET_TEXT(wz_clist4, pomiar, 1, &trik);
			sprintf(buff, "%-42s|", trik);
			fputs(buff, fp);

		CLIST_GET_TEXT(wz_clist4, pomiar, 3, &trik);
			sprintf(buff, "%15.2f|", atof(trik));
			fputs(buff, fp);

		CLIST_GET_TEXT(wz_clist4, pomiar, 2, &trik);
			sprintf(buff, "%-4s|", trik);
			fputs(buff, fp);

		CLIST_GET_TEXT(wz_clist4, pomiar, 4, &trik);
		if(strcmp(trik, "") == 0)
			sprintf(buff, "%8s|", trik);
		else
			sprintf(buff, "%8.2f|", atof(trik));
		fputs(buff, fp);

		for(a=1; a < 33; a++)
			fputs(" ", fp);
		fputs("|\n", fp);
	pomiar++;
	lp++;
	}
	fputs("+--------------------------------------------------------------------------------------------------------------+\n", fp);			
	fputs("\n", fp);
	fputs("\n", fp);
	fputs("\n", fp);
	fputs("\n", fp);
	fputs("Podpis osoby uprawnionej do                                                    Podpis osoby uprawnionej do ", fp);
	fputs("\n", fp);
	fputs("otrzymania dokumentu WZ				                               wystawienia dokumentu WZ", fp);
	for(a=1;a<8;a++)
		fputs("\n", fp);
	szukaj("/etc/xdefactor/autor", "wersja", buff_);
	sprintf(buff, "XdeFactor v%s Copyright (c) 2001-2002 by M.Ociepka armadillo@wp.pl tel.(034)317-11-15 /powered by LINUX/", buff_);
	fputs(buff, fp);

	chdir(home);
	fclose(fp);

	nr_wz(key);
	sprintf(buff, "INSERT INTO wz(nr_wz, nazwa_firmy, nip_firmy, data_wysylki, data_wystawienia, zamowienie, wysylka_na_koszt, magazyn_nr, srodek_transportu) VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s');", key, nazwa_firm, PQgetvalue(res, 0, 0), ENTRY_GET_TEXT(wz_entry4), ENTRY_GET_TEXT(wz_entry5), ENTRY_GET_TEXT(wz_entry6), ENTRY_GET_TEXT(combo_wz_entry1), ENTRY_GET_TEXT(wz_entry9), ENTRY_GET_TEXT(wz_entry7));
	
	PQexec(conn, buff);

	key[strlen(key) - 3] = '#';
	sprintf(buff, "mv wz_swap /etc/xdefactor/archiwum/wz_%s", key);
		system(buff);
	sprintf(buff, "a2ps -B -R --columns=1 -f 8 -Xiso2 -n 2 /etc/xdefactor/archiwum/wz_%s", key);
		system(buff);

	
	message_dlg("Dokument WZ zosta wysany do druku!!\n\n\t XdeFactor", "info");

}
